Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -5087,29 +5000,31 @@
 !--      and profile is logaritmic (linear in nz).
 !--      Horizontal surfaces
-         DO  m = 1, surf_usm_h%ns
-!
-!--         Roof
-            IF ( surf_usm_h%isroof_surf(m) )  THEN
-                tin = roof_inner_temperature
-                twin = window_inner_temperature
-!
-!--         Normal land surface
-            ELSE
-                tin = soil_inner_temperature
-                twin = window_inner_temperature
-            ENDIF
-
-            DO k = nzb_wall, nzt_wall+1
-                c = REAL( k - nzb_wall, wp ) / REAL( nzt_wall + 1 - nzb_wall , wp )
-
-                t_wall_h(k,m) = ( 1.0_wp - c ) * t_surf_wall_h(m) + c * tin
-                t_window_h(k,m) = ( 1.0_wp - c ) * t_surf_window_h(m) + c * twin
-                t_green_h(k,m) = t_surf_wall_h(m)
-                swc_h(k,m) = 0.5_wp
-                swc_sat_h(k,m) = 0.95_wp
-                swc_res_h(k,m) = 0.05_wp
-                rootfr_h(k,m) = 0.1_wp
-                wilt_h(k,m) = 0.1_wp
-                fc_h(k,m) = 0.9_wp
+         DO  l = 0, 1
+            DO  m = 1, surf_usm_h(l)%ns
+!
+!--            Roof
+               IF ( surf_usm_h(l)%isroof_surf(m) )  THEN
+                   tin = roof_inner_temperature
+                   twin = window_inner_temperature
+!
+!--            Normal land surface
+               ELSE
+                   tin = soil_inner_temperature
+                   twin = window_inner_temperature
+               ENDIF
+
+               DO k = nzb_wall, nzt_wall+1
+                   c = REAL( k - nzb_wall, wp ) / REAL( nzt_wall + 1 - nzb_wall , wp )
+
+                   t_wall_h(l)%val(k,m) = ( 1.0_wp - c ) * t_surf_wall_h(l)%val(m) + c * tin
+                   t_window_h(l)%val(k,m) = ( 1.0_wp - c ) * t_surf_window_h(l)%val(m) + c * twin
+                   t_green_h(l)%val(k,m) = t_surf_wall_h(l)%val(m)
+                   swc_h(l)%val(k,m) = 0.5_wp
+                   swc_sat_h(l)%val(k,m) = 0.95_wp
+                   swc_res_h(l)%val(k,m) = 0.05_wp
+                   rootfr_h(l)%val(k,m) = 0.1_wp
+                   wilt_h(l)%val(k,m) = 0.1_wp
+                   fc_h(l)%val(k,m) = 0.9_wp
+               ENDDO
             ENDDO
          ENDDO
@@ -5125,15 +5040,11 @@
                DO k = nzb_wall, nzt_wall+1
                   c = REAL( k - nzb_wall, wp ) / REAL( nzt_wall + 1 - nzb_wall , wp )
-                  t_wall_v(l)%t(k,m) = ( 1.0_wp - c ) * t_surf_wall_v(l)%t(m) + c * tin
-                  t_window_v(l)%t(k,m) = ( 1.0_wp - c ) * t_surf_window_v(l)%t(m) + c * twin
-                  t_green_v(l)%t(k,m) = t_surf_wall_v(l)%t(m)
+                  t_wall_v(l)%val(k,m) = ( 1.0_wp - c ) * t_surf_wall_v(l)%val(m) + c * tin
+                  t_window_v(l)%val(k,m) = ( 1.0_wp - c ) * t_surf_window_v(l)%val(m) + c * twin
+                  t_green_v(l)%val(k,m) = t_surf_wall_v(l)%val(m)
                ENDDO
             ENDDO
          ENDDO
      ENDIF
-
-!
-!--  If specified, replace constant wall temperatures with fully 3D values from file
-     IF ( read_wall_temp_3d )  CALL usm_read_wall_temperature()
 
 !--
@@ -5159,14 +5070,16 @@
 !
 !-- Set initial values for prognostic soil quantities
-    IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
-       m_liq_usm_h%var_usm_1d  = 0.0_wp
-    ENDIF
-    m_liq_usm_h_p = m_liq_usm_h
-!
-!-- Set initial values for prognostic quantities
-!-- Horizontal surfaces
-    surf_usm_h%c_liq     = 0.0_wp
-    surf_usm_h%qsws_liq  = 0.0_wp
-    surf_usm_h%qsws_veg  = 0.0_wp
+    DO  l = 0, 1
+       IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+          m_liq_usm_h(l)%val  = 0.0_wp
+       ENDIF
+       m_liq_usm_h_p(l)%val = m_liq_usm_h(l)%val
+!
+!--    Set initial values for prognostic quantities
+!--    Horizontal surfaces
+       surf_usm_h(l)%c_liq     = 0.0_wp
+       surf_usm_h(l)%qsws_liq  = 0.0_wp
+       surf_usm_h(l)%qsws_veg  = 0.0_wp
+    ENDDO
 
 !
@@ -5195,12 +5108,14 @@
 !> during spinup to increase possible timestep.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE usm_material_heat_model( during_spinup )
+ SUBROUTINE usm_wall_heat_model( horizontal, l, during_spinup )
 
 
     IMPLICIT NONE
 
-    INTEGER(iwp)  ::  i,j,k,l,kw, m  !< running indices
-
-    LOGICAL  ::  during_spinup  !< if true, no calculation of window temperatures
+    LOGICAL       ::  horizontal     !< Flag indicating horizontal or vertical surfaces
+    INTEGER(iwp)  ::  l              !< direction index
+    LOGICAL       ::  during_spinup  !< if true, no calculation of window temperatures
+
+    INTEGER(iwp)  ::  i,j,k,kw, m    !< running indices
 
     REAL(wp)  ::  win_absorp  !< absorption coefficient from transmissivity
@@ -5209,8 +5124,13 @@
     REAL(wp), DIMENSION(nzb_wall:nzt_wall)  ::  wtend, wintend  !< tendency
 
-
+    TYPE(surf_type),        POINTER         ::  surf            !< surface-date type variable
+    TYPE(surf_type_2d_usm), POINTER         ::  t_wall
+    TYPE(surf_type_2d_usm), POINTER         ::  t_wall_p
+    TYPE(surf_type_2d_usm), POINTER         ::  t_window
+    TYPE(surf_type_2d_usm), POINTER         ::  t_window_p
+    TYPE(surf_type_2d_usm), POINTER         ::  t_green
 
     IF ( debug_output_timestep )  THEN
-       WRITE( debug_string, * ) 'usm_material_heat_model | during_spinup: ', during_spinup
+       WRITE( debug_string, * ) 'usm_wall_heat_model: ', horizontal, l, during_spinup
        CALL debug_message( debug_string, 'start' )
     ENDIF
@@ -5224,140 +5144,157 @@
     ENDIF
 
-!
-!-- For horizontal surfaces
+    IF ( horizontal )  THEN
+       surf         => surf_usm_h(l)
+       t_wall       => t_wall_h(l)
+       t_wall_p     => t_wall_h_p(l)
+       t_window     => t_window_h(l)
+       t_window_p   => t_window_h_p(l)
+       t_green      => t_green_h(l)
+    ELSE
+       surf         => surf_usm_v(l)
+       t_wall       => t_wall_v(l)
+       t_wall_p     => t_wall_v_p(l)
+       t_window     => t_window_v(l)
+       t_window_p   => t_window_v_p(l)
+       t_green      => t_green_v(l)
+    ENDIF
+!
+!-- Cycle for all surfaces in given direction
     !$OMP DO SCHEDULE (STATIC)
-    DO  m = 1, surf_usm_h%ns
+    DO  m = 1, surf%ns
 !
 !--    Obtain indices
-       i = surf_usm_h%i(m)
-       j = surf_usm_h%j(m)
-       k = surf_usm_h%k(m)
-!
-!--    Prognostic equation for ground/roof temperature t_wall_h
+       i = surf%i(m)
+       j = surf%j(m)
+       k = surf%k(m)
+!
+!--    Prognostic equation for ground/roof temperature t_wall
        wtend(:) = 0.0_wp
-       wtend(nzb_wall) = ( 1.0_wp / surf_usm_h%rho_c_wall(nzb_wall,m) )                            &
-                          * ( surf_usm_h%lambda_h(nzb_wall,m) * wall_mod(nzb_wall)                 &
-                              * ( t_wall_h(nzb_wall+1,m) - t_wall_h(nzb_wall,m) )                  &
-                              * surf_usm_h%ddz_wall(nzb_wall+1,m)                                  &
-                              + surf_usm_h%frac(m,ind_veg_wall)                                    &
-                              / ( surf_usm_h%frac(m,ind_veg_wall)                                  &
-                                  + surf_usm_h%frac(m,ind_pav_green) )                             &
-                              * surf_usm_h%wghf_eb(m)                                              &
-                              - surf_usm_h%frac(m,ind_pav_green)                                   &
-                              / ( surf_usm_h%frac(m,ind_veg_wall)                                  &
-                                  + surf_usm_h%frac(m,ind_pav_green) )                             &
-                              * ( surf_usm_h%lambda_h_green(nzt_wall,m)                            &
-                              * wall_mod(nzt_wall)                                                 &
-                              * surf_usm_h%ddz_green(nzt_wall,m)                                   &
-                              + surf_usm_h%lambda_h(nzb_wall,m)                                    &
-                              * wall_mod(nzb_wall)                                                 &
-                              * surf_usm_h%ddz_wall(nzb_wall,m) )                                  &
-                              / ( surf_usm_h%ddz_green(nzt_wall,m)                                 &
-                              + surf_usm_h%ddz_wall(nzb_wall,m) )                                  &
-                              * ( t_wall_h(nzb_wall,m) - t_green_h(nzt_wall,m) )                   &
-                            ) * surf_usm_h%ddz_wall_stag(nzb_wall,m)
-!
-!-- If indoor model is used inner wall layer is calculated by using iwghf (indoor wall ground heat flux)
+       wtend(nzb_wall) = ( 1.0_wp / surf%rho_c_wall(nzb_wall,m) )                     &
+                          * ( surf%lambda_h(nzb_wall,m) * wall_mod(nzb_wall)          &
+                              * ( t_wall%val(nzb_wall+1,m) - t_wall%val(nzb_wall,m) )              &
+                              * surf%ddz_wall(nzb_wall+1,m)                           &
+                              + surf%frac(m,ind_veg_wall)                             &
+                              / ( surf%frac(m,ind_veg_wall)                           &
+                                  + surf%frac(m,ind_pav_green) )                      &
+                              * surf%wghf_eb(m)                                       &
+                              - surf%frac(m,ind_pav_green)                            &
+                              / ( surf%frac(m,ind_veg_wall)                           &
+                                  + surf%frac(m,ind_pav_green) )                      &
+                              * ( surf%lambda_h_green(nzt_wall,m)                     &
+                              * wall_mod(nzt_wall)                                             &
+                              * surf%ddz_green(nzt_wall,m)                            &
+                              + surf%lambda_h(nzb_wall,m)                             &
+                              * wall_mod(nzb_wall)                                             &
+                              * surf%ddz_wall(nzb_wall,m) )                           &
+                              / ( surf%ddz_green(nzt_wall,m)                          &
+                              + surf%ddz_wall(nzb_wall,m) )                           &
+                              * ( t_wall%val(nzb_wall,m) - t_green%val(nzt_wall,m) )               &
+                            ) * surf%ddz_wall_stag(nzb_wall,m)
+!
+!--    If indoor model is used inner wall layer is calculated by using iwghf (indoor wall ground heat flux)
        IF ( indoor_model )  THEN
           DO  kw = nzb_wall+1, nzt_wall-1
-             wtend(kw) = ( 1.0_wp / surf_usm_h%rho_c_wall(kw,m) )                                  &
-                         * ( surf_usm_h%lambda_h(kw,m)                                             &
-                             * wall_mod(kw)                                                        &
-                             * ( t_wall_h(kw+1,m) - t_wall_h(kw,m) )                               &
-                             * surf_usm_h%ddz_wall(kw+1,m)                                         &
-                             - surf_usm_h%lambda_h(kw-1,m)                                         &
-                             * wall_mod(kw-1)                                                      &
-                             * ( t_wall_h(kw,m) - t_wall_h(kw-1,m) )                               &
-                             * surf_usm_h%ddz_wall(kw,m)                                           &
-                           ) * surf_usm_h%ddz_wall_stag(kw,m)
+             wtend(kw) = ( 1.0_wp / surf%rho_c_wall(kw,m) )                           &
+                         * ( surf%lambda_h(kw,m) * wall_mod(kw)                       &
+                             * ( t_wall%val(kw+1,m) - t_wall%val(kw,m) )                           &
+                             * surf%ddz_wall(kw+1,m)                                  &
+                             - surf%lambda_h(kw-1,m) * wall_mod(kw-1)                 &
+                             * ( t_wall%val(kw,m) - t_wall%val(kw-1,m) )                           &
+                             * surf%ddz_wall(kw,m)                                    &
+                           ) * surf%ddz_wall_stag(kw,m)
           ENDDO
-          wtend(nzt_wall) = ( 1.0_wp / surf_usm_h%rho_c_wall(nzt_wall,m) )                         &
-                            * ( -surf_usm_h%lambda_h(nzt_wall-1,m) * wall_mod(nzt_wall-1)          &
-                                * ( t_wall_h(nzt_wall,m) - t_wall_h(nzt_wall-1,m) )                &
-                                * surf_usm_h%ddz_wall(nzt_wall,m)                                  &
-                                + surf_usm_h%iwghf_eb(m)                                           &
-                              ) * surf_usm_h%ddz_wall_stag(nzt_wall,m)
+          wtend(nzt_wall) = ( 1.0_wp / surf%rho_c_wall(nzt_wall,m) )                  &
+                            * ( -surf%lambda_h(nzt_wall-1,m) * wall_mod(nzt_wall-1)   &
+                                * ( t_wall%val(nzt_wall,m) - t_wall%val(nzt_wall-1,m) )            &
+                                * surf%ddz_wall(nzt_wall,m)                           &
+                                + surf%iwghf_eb(m)                                    &
+                              ) * surf%ddz_wall_stag(nzt_wall,m)
        ELSE
           DO  kw = nzb_wall+1, nzt_wall
-             wtend(kw) = ( 1.0_wp / surf_usm_h%rho_c_wall(kw,m) )                                  &
-                        * ( surf_usm_h%lambda_h(kw,m)  * wall_mod(kw)                              &
-                            * ( t_wall_h(kw+1,m) - t_wall_h(kw,m) )                                &
-                            * surf_usm_h%ddz_wall(kw+1,m)                                          &
-                            - surf_usm_h%lambda_h(kw-1,m)                                          &
-                            * wall_mod(kw-1)                                                       &
-                            * ( t_wall_h(kw,m) - t_wall_h(kw-1,m) )                                &
-                            * surf_usm_h%ddz_wall(kw,m)                                            &
-                          ) * surf_usm_h%ddz_wall_stag(kw,m)
+             wtend(kw) = ( 1.0_wp / surf%rho_c_wall(kw,m) )                           &
+                        * ( surf%lambda_h(kw,m)  * wall_mod(kw)                       &
+                            * ( t_wall%val(kw+1,m) - t_wall%val(kw,m) )                            &
+                            * surf%ddz_wall(kw+1,m)                                   &
+                            - surf%lambda_h(kw-1,m) * wall_mod(kw-1)                  &
+                            * ( t_wall%val(kw,m) - t_wall%val(kw-1,m) )                            &
+                            * surf%ddz_wall(kw,m)                                     &
+                          ) * surf%ddz_wall_stag(kw,m)
           ENDDO
        ENDIF
 
-       t_wall_h_p(nzb_wall:nzt_wall,m) = t_wall_h(nzb_wall:nzt_wall,m) + dt_3d                     &
-                                         * ( tsc(2) * wtend(nzb_wall:nzt_wall) + tsc(3)            &
-                                             * surf_usm_h%tt_wall_m(nzb_wall:nzt_wall,m) )
-
-!
-!-- During spinup the tempeature inside window layers is not calculated to make larger timesteps possible
+       t_wall_p%val(nzb_wall:nzt_wall,m) = t_wall%val(nzb_wall:nzt_wall,m) + dt_3d                 &
+                                         * ( tsc(2) * wtend(nzb_wall:nzt_wall) + tsc(3)        &
+                                             * surf%tt_wall_m(nzb_wall:nzt_wall,m) )
+
+!
+!--    During spinup the tempeature inside window layers is not calculated to make larger timesteps possible
        IF ( .NOT. during_spinup )  THEN
-          win_absorp = -log( surf_usm_h%transmissivity(m) ) / surf_usm_h%zw_window(nzt_wall,m)
-!
-!--       Prognostic equation for ground/roof window temperature t_window_h takes absorption of
-!--       shortwave radiation into account
+          win_absorp = -log( surf%transmissivity(m) ) /                                &
+                        surf%zw_window(nzt_wall,m)
+!
+!--       Prognostic equation for ground/roof window temperature t_window takes absorption
+!--       of shortwave radiation into account
           wintend(:) = 0.0_wp
-          wintend(nzb_wall) = ( 1.0_wp / surf_usm_h%rho_c_window(nzb_wall,m) ) *                   &
-                              ( surf_usm_h%lambda_h_window(nzb_wall,m)                             &
-                                * ( t_window_h(nzb_wall+1,m) - t_window_h(nzb_wall,m) )            &
-                                * surf_usm_h%ddz_window(nzb_wall+1,m)                              &
-                                + surf_usm_h%wghf_eb_window(m)                                     &
-                                + surf_usm_h%rad_sw_in(m)                                          &
-                                * ( 1.0_wp - exp( -win_absorp * surf_usm_h%zw_window(nzb_wall,m) ) ) &
-                              ) * surf_usm_h%ddz_window_stag(nzb_wall,m)
+          wintend(nzb_wall) = ( 1.0_wp / surf%rho_c_window(nzb_wall,m) )               &
+                                * ( surf%lambda_h_window(nzb_wall,m)                   &
+                                * ( t_window%val(nzb_wall+1,m) - t_window%val(nzb_wall,m) )         &
+                                * surf%ddz_window(nzb_wall+1,m)                        &
+                                + surf%wghf_eb_window(m)                               &
+                                + surf%rad_sw_in(m)                                    &
+                                * ( 1.0_wp - exp( -win_absorp                                   &
+                                    * surf%zw_window(nzb_wall,m) ) )                   &
+                              ) * surf%ddz_window_stag(nzb_wall,m)
 
           IF ( indoor_model ) THEN
              DO  kw = nzb_wall+1, nzt_wall-1
-                wintend(kw) = ( 1.0_wp / surf_usm_h%rho_c_window(kw,m) )                           &
-                              * ( surf_usm_h%lambda_h_window(kw,m)                                 &
-                                  * ( t_window_h(kw+1,m) - t_window_h(kw,m) )                      &
-                                  * surf_usm_h%ddz_window(kw+1,m)                                  &
-                                  - surf_usm_h%lambda_h_window(kw-1,m)                             &
-                                 * ( t_window_h(kw,m) - t_window_h(kw-1,m) )                       &
-                                 * surf_usm_h%ddz_window(kw,m)                                     &
-                                 + surf_usm_h%rad_sw_in(m)                                         &
-                                 * ( exp( -win_absorp * surf_usm_h%zw_window(kw-1,m) )             &
-                                     - exp(-win_absorp * surf_usm_h%zw_window(kw,m) )              &
-                                   )                                                               &
-                                 ) * surf_usm_h%ddz_window_stag(kw,m)
+                wintend(kw) = ( 1.0_wp / surf%rho_c_window(kw,m) )                     &
+                              * ( surf%lambda_h_window(kw,m)                           &
+                                  * ( t_window%val(kw+1,m) - t_window%val(kw,m) )                   &
+                                  * surf%ddz_window(kw+1,m)                            &
+                                  - surf%lambda_h_window(kw-1,m)                       &
+                                 * ( t_window%val(kw,m) - t_window%val(kw-1,m) )                    &
+                                 * surf%ddz_window(kw,m)                               &
+                                 + surf%rad_sw_in(m)                                   &
+                                 * ( exp( -win_absorp * surf%zw_window(kw-1,m) )       &
+                                     - exp(-win_absorp * surf%zw_window(kw,m) )        &
+                                   )                                                            &
+                                 ) * surf%ddz_window_stag(kw,m)
 
              ENDDO
-             wintend(nzt_wall) = ( 1.0_wp / surf_usm_h%rho_c_window(nzt_wall,m) )                  &
-                                 * ( -surf_usm_h%lambda_h_window(nzt_wall-1,m)                     &
-                                    * ( t_window_h(nzt_wall,m) - t_window_h(nzt_wall-1,m) )        &
-                                    * surf_usm_h%ddz_window(nzt_wall,m)                            &
-                                    + surf_usm_h%iwghf_eb_window(m)                                &
-                                    + surf_usm_h%rad_sw_in(m)                                      &
-                                    * ( exp( -win_absorp * surf_usm_h%zw_window(nzt_wall-1,m) )    &
-                                        - exp( -win_absorp * surf_usm_h%zw_window(nzt_wall,m) )    &
-                                      )                                                            &
-                                    ) * surf_usm_h%ddz_window_stag(nzt_wall,m)
+             wintend(nzt_wall) = ( 1.0_wp / surf%rho_c_window(nzt_wall,m) )            &
+                                 * ( -surf%lambda_h_window(nzt_wall-1,m)               &
+                                    * ( t_window%val(nzt_wall,m) - t_window%val(nzt_wall-1,m) )     &
+                                    * surf%ddz_window(nzt_wall,m)                      &
+                                    + surf%iwghf_eb_window(m)                          &
+                                    + surf%rad_sw_in(m)                                &
+                                    * ( exp( -win_absorp                                        &
+                                        * surf%zw_window(nzt_wall-1,m) )               &
+                                      - exp( -win_absorp                                        &
+                                        * surf%zw_window(nzt_wall,m) )                 &
+                                      )                                                         &
+                                    ) * surf%ddz_window_stag(nzt_wall,m)
           ELSE
              DO  kw = nzb_wall+1, nzt_wall
-                wintend(kw) = ( 1.0_wp / surf_usm_h%rho_c_window(kw,m) )                           &
-                              * ( surf_usm_h%lambda_h_window(kw,m)                                 &
-                                  * ( t_window_h(kw+1,m) - t_window_h(kw,m) )                      &
-                                  * surf_usm_h%ddz_window(kw+1,m)                                  &
-                                  - surf_usm_h%lambda_h_window(kw-1,m)                             &
-                                  * ( t_window_h(kw,m)                                             &
-                                  - t_window_h(kw-1,m) )                                           &
-                                  * surf_usm_h%ddz_window(kw,m) + surf_usm_h%rad_sw_in(m)          &
-                                   * ( exp( -win_absorp * surf_usm_h%zw_window(kw-1,m) )           &
-                                       - exp(-win_absorp * surf_usm_h%zw_window(kw,m) )            &
-                                     )                                                             &
-                                 ) * surf_usm_h%ddz_window_stag(kw,m)
+                wintend(kw) = ( 1.0_wp / surf%rho_c_window(kw,m) )                     &
+                              * ( surf%lambda_h_window(kw,m)                           &
+                                  * ( t_window%val(kw+1,m) - t_window%val(kw,m) )                   &
+                                  * surf%ddz_window(kw+1,m)                            &
+                                  - surf%lambda_h_window(kw-1,m)                       &
+                                  * ( t_window%val(kw,m)                                          &
+                                  - t_window%val(kw-1,m) )                                        &
+                                  * surf%ddz_window(kw,m)                              &
+                                  + surf%rad_sw_in(m)                                  &
+                                   * ( exp( -win_absorp * surf%zw_window(kw-1,m) )     &
+                                       - exp(-win_absorp * surf%zw_window(kw,m) )      &
+                                     )                                                          &
+                                 ) * surf%ddz_window_stag(kw,m)
 
              ENDDO
           ENDIF
 
-          t_window_h_p(nzb_wall:nzt_wall,m) = t_window_h(nzb_wall:nzt_wall,m) + dt_3d              &
-                                              * ( tsc(2) * wintend(nzb_wall:nzt_wall) + tsc(3)     &
-                                                  * surf_usm_h%tt_window_m(nzb_wall:nzt_wall,m) )
+          t_window_p%val(nzb_wall:nzt_wall,m) = t_window%val(nzb_wall:nzt_wall,m) + dt_3d           &
+                                              * ( tsc(2) * wintend(nzb_wall:nzt_wall) + tsc(3)  &
+                                              * surf%tt_window_m(nzb_wall:nzt_wall,m) )
 
        ENDIF
@@ -5368,10 +5305,10 @@
            IF ( intermediate_timestep_count == 1 )  THEN
               DO  kw = nzb_wall, nzt_wall
-                 surf_usm_h%tt_wall_m(kw,m) = wtend(kw)
+                 surf%tt_wall_m(kw,m) = wtend(kw)
               ENDDO
            ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
                DO  kw = nzb_wall, nzt_wall
-                  surf_usm_h%tt_wall_m(kw,m) = -9.5625_wp * wtend(kw) +                            &
-                                               5.3125_wp * surf_usm_h%tt_wall_m(kw,m)
+                  surf%tt_wall_m(kw,m) = -9.5625_wp * wtend(kw) +                            &
+                                               5.3125_wp * surf%tt_wall_m(kw,m)
                ENDDO
            ENDIF
